<?php
/********************************************************************************
* ABClock.php v1.0												*
* By Karl Benson													*
*********************************************************************************
This program is distributed in the hope that it is and will be useful, but
WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.
********************************************************************************/
if (!defined('SMF'))
	die('Hacking attempt...');

function GenerateClock()
{
	global $settings, $modSettings;
	
	// Attempt to stop from dying... (not that it should)
	@set_time_limit(0);
	@ini_set('memory_limit', '112M');

	// Must have received the session variable
	if(empty($_SESSION['abclock']) || !is_array($_SESSION['abclock']))
	{
		// Unset as its unvalid
		unset($_SESSION['abclock']);
		header('HTTP/1.1 400 Bad Request');
		die();
	}
	
	// Change the time, reset uses, but keep the same field
	$sethour = 12 - rand(1,12) ;
	$setminute = 12 - rand(1,12);
	
	// Work Out the Answer
	// - Minutes
	// Less than 10 (2*5) means single digit, so turn it into double digits
	if($setminute < 2)
		$answer_minute = '0'.($setminute * 5);
	else
		$answer_minute = $setminute * 5;
		
	// - Hour (remember were using 12  not 24 hr clock)
	if($sethour == 0)
		$answer_hour = '12';
	elseif($sethour < 10)
		$answer_hour = '0'.$sethour;
	else
		$answer_hour = $sethour;

	// - Answer : Store MD5'd to compare against
	$_SESSION['abclock']['answer'] = md5($answer_hour.':'.$answer_minute);
	
	// Tidy up
	unset($answer_minute, $answer_hour);
	
	// Now to Create the Clock
	
	// Face selection
	$rand = rand(1,5);
	$face = $settings['default_theme_dir'].'/images/clocks/face'.$rand.'.png';
	// Hands selection (Use same type for hour and minute hands)
	$rand = rand(1,5);
	$hour = $settings['default_theme_dir'].'/images/clocks/hour'.$rand.'.png';
	$minute = $settings['default_theme_dir'].'/images/clocks/minute'.$rand.'.png';
	
	// Rotation? Get our time *30 (less some shift hour hand depending on minutes)
	$sethour = 360 - (($sethour * 30) + ($setminute*2.5));
	$setminute = 360 - ($setminute * 30);
	
	// -- The minute hand --
	$minute = imagecreatefrompng($minute);
	
	// Rotate if necessary
	if(!empty($setminute))
		$minute = imagerotate($minute, $setminute, -1);

	// Save Transparency/Alpha
	imageAlphaBlending($minute, true);
	imageSaveAlpha($minute, true);
		
	// Select random color
	$col1 = rand(1,255);
	$col2 = rand(1,255);
	$col3 = rand(1,255);
	// Too white?
	if($col1 + $col2 + $col3 > 750)
	{
		$col = rand(0,2);
		if($col == 0)
			$col1 = $col1 - rand(50,100);
		elseif($col == 1)
			$col2 = $col2 - rand(50,100);
		elseif($col == 2)
			$col3 = $col3 - rand(50,100);
	}
	// Colorize the minute hand
	imagefilter($minute, IMG_FILTER_COLORIZE, $col1, $col2, $col3);
	
	// -- The face --
	$face = imagecreatefrompng($face);
	
	// Add Some dots
	for($i=0;$i<=1000;$i++)
	{
		$color = imageColorAllocate($face, rand(0,256), rand(0,256), rand(0,256));
		imagesetpixel($face, rand(0,150) , rand(0,150) , $color);
	}
	
	//Get the sizes of both pix
	$face_width=imageSX($face);
	$face_height=imageSY($face);
	$minute_width=imageSX($minute);
	$minute_height=imageSY($minute);

	$dest_x = ( $face_width / 2 ) - ( $minute_width / 2 );
	$dest_y = ( $face_height / 2 ) - ( $minute_height / 2 );

	// Merge the face with minute
	imagecopy($face, $minute, $dest_x, $dest_y, 0, 0, $minute_width, $minute_height);
	
	// Destroy the minute hand as its no longer needed
	imagedestroy($minute);
	
	// -- The hour hand --
	$hour = imagecreatefrompng($hour);

	// Rotate if necessary
	if(!empty($sethour))
		$hour = imagerotate($hour, $sethour, -1);

	// Save Transparency/Alpha
	imageAlphaBlending($hour, true);
	imageSaveAlpha($hour, true);
	
	// Colorize the hour (the same as we did the minute hand)
	imagefilter($hour, IMG_FILTER_COLORIZE, $col1, $col2, $col3);

	//Get the sizes of both pix
	$hour_width = imageSX($hour);
	$hour_height = imageSY($hour);
	$dest_x = ( $face_width / 2 ) - ( $hour_width / 2 );
	$dest_y = ( $face_height / 2 ) - ( $hour_height / 2 );

	// Merge the hour onto the face
	imagecopy($face, $hour, $dest_x, $dest_y, 0, 0, $hour_width, $hour_height);
	
	// Destroy the hour hand as its no longer needed
	imagedestroy($hour);
	
	// Random Special Effects (PHP5 only)
	if (@version_compare(PHP_VERSION, '5.0.0') !== -1)
	{
		$rand = rand(0, 5);
		if($rand == 1)
			imagefilter($face, IMG_FILTER_NEGATE);
		elseif($rand == 2)
			imagefilter($face, IMG_FILTER_GRAYSCALE);
		elseif($rand == 3)
			imagefilter($face, IMG_FILTER_EDGEDETECT);
		elseif($rand == 4)
			imagefilter($face, IMG_FILTER_EMBOSS);
		elseif($rand == 5)
			imagefilter($face, IMG_FILTER_MEAN_REMOVAL);
	}

	// Headers - don't cache this
	header("Cache-Control: no-cache");
	header("Pragma: nocache");
	header('Content-type: image/png');

	// Send out the image
	imagepng ($face);

	// Destroy the images
	imagedestroy($face);

	// The end
	die();
}
?>